library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.numeric_std.all;
Library UNISIM;
use UNISIM.vcomponents.all;

entity top_level is

Port (LED					: out std_logic_vector(7 downto 0);
		BTN	  	    		: IN  STD_LOGIC;
		DIP					: in std_logic_vector(7 downto 0);
		J9						: in std_logic_vector(64 downto 0);
		J10					: in std_logic_vector(64 downto 0);
		J17					: in std_logic_vector(3 downto 0);
		J5						: in std_logic_vector(7 downto 0);
		SDA   	    		: INOUT  STD_LOGIC;
		SCL	       		: INOUT  STD_LOGIC;
		SPKR   	    		: OUT  STD_LOGIC;
		ACBUS0  	    		: IN  STD_LOGIC; -- TXDEN
		ACBUS1  	    		: IN  STD_LOGIC; -- SLEEP#
		ACBUS2  	    		: IN  STD_LOGIC; -- RXLED#
		ACBUS3  	    		: IN  STD_LOGIC; -- TXLED#
		ADBUS0  	    		: IN  STD_LOGIC; -- TXD
		ADBUS1  	    		: OUT STD_LOGIC; -- RXD
		ADBUS2  	    		: IN  STD_LOGIC; -- RTS#
		ADBUS3  	    		: OUT STD_LOGIC; -- CTS#
		ADBUS4  	    		: IN  STD_LOGIC; -- DTR#
		ADBUS5  	    		: OUT STD_LOGIC; -- DSR#
		ADBUS6  	    		: OUT STD_LOGIC; -- DCD#
		ADBUS7  	    		: OUT STD_LOGIC; -- RI#
		BCBUS0  	    		: IN  STD_LOGIC; -- TXDEN
		BCBUS1  	    		: IN  STD_LOGIC; -- SLEEP#
		BCBUS2  	    		: IN  STD_LOGIC; -- RXLED#
		BCBUS3  	    		: IN  STD_LOGIC; -- TXLED#
		BDBUS0  	    		: IN  STD_LOGIC; -- TXD
		BDBUS1  	    		: OUT STD_LOGIC; -- RXD
		BDBUS2  	    		: IN  STD_LOGIC; -- RTS#
		BDBUS3  	    		: OUT STD_LOGIC; -- CTS#
		BDBUS4  	    		: IN  STD_LOGIC; -- DTR#
		BDBUS5  	    		: OUT STD_LOGIC; -- DSR#
		BDBUS6  	    		: OUT STD_LOGIC; -- DCD#
		BDBUS7  	    		: OUT STD_LOGIC; -- RI#
		R_B2	  	    		: IN  STD_LOGIC;
		R_B1	  	    		: IN  STD_LOGIC;
		RE 	  	    		: OUT STD_LOGIC;
		CE1 	  	    		: OUT STD_LOGIC;
		CE2 	  	    		: OUT STD_LOGIC;
		CLE 	  	    		: OUT STD_LOGIC;
		ALE 	  	    		: OUT STD_LOGIC;
		WE 		  	    	: OUT STD_LOGIC;
		WP 		  	    	: OUT STD_LOGIC;
		NAND_IO 	  	    	: INOUT  std_logic_vector(7 downto 0);
		CLK					: in std_logic);
end top_level;

architecture Behavioral of top_level is
----------------------------------------------
	component uart_tx
	port (
    i_clk       : in  std_logic;
    i_tx_dv     : in  std_logic;
    i_tx_byte   : in  std_logic_vector(7 downto 0);
    o_tx_active : out std_logic;
    o_tx_serial : out std_logic;
    o_tx_done   : out std_logic
    );
	END component;

	component uart_rx
	port (
    i_clk       : in  std_logic;
    i_rx_serial : in  std_logic;
    o_rx_dv     : out std_logic;
    o_rx_byte   : out std_logic_vector(7 downto 0)
    );
	END component;

	COMPONENT i2c_master
	PORT(
		clk : IN std_logic;
		reset_n : IN std_logic;
		ena : IN std_logic;
		addr : IN std_logic_vector(6 downto 0);
		rw : IN std_logic;
		data_wr : IN std_logic_vector(7 downto 0);    
		sda : INOUT std_logic;
		scl : INOUT std_logic;      
		busy : OUT std_logic;
		data_rd : OUT std_logic_vector(7 downto 0);
		ack_error : OUT std_logic
		);
	END COMPONENT;

	COMPONENT music
	PORT(
		clk : IN std_logic;          
		speaker : OUT std_logic
		);
	END COMPONENT;
---------------------------------------------
signal i_o			:STD_LOGIC_VECTOR(149 downto 0);
signal timer		:STD_LOGIC_VECTOR(35 downto 0);
signal count_d,count_n 	:STD_LOGIC_VECTOR(24 DOWNTO 0);
signal count_pwr  :STD_LOGIC_VECTOR(18 DOWNTO 0);
signal rx_data,i2c_data_rd,i2c_data_wr,o_rx_data,led1,led2,led3,led4,led0,dip1,dip3,io_sum,led5,i2c_data_write :STD_LOGIC_VECTOR(7 DOWNTO 0);
signal mode			:STD_LOGIC_VECTOR(4 downto 0);
signal rx_dv,s_1,s_2,s_3,s_4,s_5,tx_dv,ena_i2c_write,power_up,reset,tx_dv_en,lock_rx,ftdi_mode,prog_mode,read_second_chip,check_cycle3,C1_C1,C1_C2,C1_C3,C1_C4,C1_C5,
io_test_mode,music_mode,nand_mode,tx_serial,five_sec,sound2,ena_i2c,ena_i2c_read,stop_iic,i2c_busy,rw_i2c,NAND_CE,check_cycle1,check_cycle2,C2_C1,C2_C2,C2_C3,C2_C4,C2_C5,
rst_i2c,count_start,start_iic,rx_serial,CE,five_min,ten_min,rx_data_switch,ok,sound1,stop_nand,n_count_start,check_cycle4,check_cycle5,NAND_ID_OK,NAND_test_result :STD_LOGIC;
---------------------------------------------
begin

	uarttx: uart_tx
	port map(	i_clk			=> clk,
					i_tx_dv		=> tx_dv,
					i_tx_byte	=> i2c_data_rd,
--					o_tx_active => ,
--					o_tx_done 	=> ,
					o_tx_serial	=> tx_serial);
					
	uartrx: uart_rx
	port map(	i_clk			=> clk,
					i_rx_serial => rx_serial,
					o_rx_dv 		=> rx_dv,
					o_rx_byte	=> o_rx_data);


	Inst_i2c_master: i2c_master PORT MAP(
		clk => clk,
		reset_n => rst_i2c,
		ena => ena_i2c,
		addr => "1010000", -- AT24C1024 EEPROM ADDRESS (set "1010001" for the "second half")
		rw => rw_i2c,
		data_wr => i2c_data_write,
		busy => i2c_busy,
		data_rd => i2c_data_rd,
--		ack_error => ,
		sda => sda,
		scl => scl
	);

	Inst_music: music PORT MAP(
		clk => clk,
		speaker => sound2
	);
---------------------------------------------------------
reset <= btn;

	process(clk,reset)
	begin
	  if (reset='0') then
    count_pwr <= (others => '0');
  elsif (clk'event and clk = '1') then
      if (CE='0') then
			count_pwr <= count_pwr + '1';
		end if;
		end if;
	end process;
	
CE <= '1' when count_pwr= X"7FFFF" else '0';
power_up <= '1' when count_pwr= X"7FFFE" else '0'; --wait until EEPROM is ready
rx_data_switch  <= power_up or five_sec or five_min or ten_min;

process(rx_data_switch,rx_dv,o_rx_data)
begin
  if (rx_data_switch = '1') then
      rx_data <= "00000000";
  elsif (rx_dv = '1') then
		rx_data <= o_rx_data;
  end if;
end process;

tx_dv <= not i2c_busy and tx_dv_en;
	
s_1 <= '1' when o_rx_data= "00110001" and rx_dv='1' else '0';
s_2 <= '1' when o_rx_data= "00110010" and rx_dv='1'  else '0';
s_3 <= '1' when o_rx_data= "00110011" and rx_dv='1'  else '0';
s_4 <= '1' when o_rx_data= "00110100" and rx_dv='1'  else '0';
s_5 <= '1' when o_rx_data= "00110101" and rx_dv='1'  else '0';

	process(clk,rx_dv)
	begin
	  if (rx_dv='1') then
    timer <= (others => '0');
  elsif (clk'event and clk = '1') then 
			timer <= timer + '1';
		end if;
	end process;

five_sec <= '1' when timer= X"1DCD6500" and ((music_mode = '1') or (nand_mode = '1')) else '0';
five_min <= '1' when timer= X"6FC23AC00" and ftdi_mode = '1' else '0';
ten_min <= '1' when timer= X"DF8475800" and io_test_mode = '1' else '0';

process(s_1,five_min,power_up)
begin
  if (five_min = '1') or (power_up = '1') then
      ftdi_mode <= '0';
  elsif (s_1 = '1') then
		ftdi_mode <= '1';
  end if;
end process;

process(s_2,power_up)
begin
  if (power_up = '1') then
      prog_mode <= '0';
  elsif (s_2 = '1') then
		prog_mode <= '1';
  end if;
end process;

process(s_3,ten_min,power_up)
begin
  if (ten_min = '1') or (power_up = '1') then
      io_test_mode <= '0';
  elsif (s_3 = '1') then
		io_test_mode <= '1';
  end if;
end process;

process(s_4,five_sec,power_up)
begin
  if (five_sec = '1') or (power_up = '1') then
      music_mode <= '0';
  elsif (s_4 = '1') then
		music_mode <= '1';
  end if;
end process;

process(s_5,five_sec,power_up)
begin
  if (five_sec = '1') or (power_up = '1') then
      nand_mode <= '0';
  elsif (s_5 = '1') then
		nand_mode <= '1';
  end if;
end process;

mode(0) <= ftdi_mode;
mode(1) <= prog_mode;
mode(2) <= io_test_mode;
mode(3) <= music_mode;
mode(4) <= nand_mode;

process(mode,led1,DIP,led2,led3,led4,led0,led5)
begin
	   case mode is
		when "00001" => led<=led1; dip1<=dip; dip3<=X"FF";
      when "00010" => led<=led2; dip1<=X"FF"; dip3<=X"FF";
		when "00100" => led<=led3; dip1<=X"FF"; dip3<=dip;
		when "01000" => led<=led4; dip1<=X"FF"; dip3<=X"FF";
		when "10000" => led<=led5; dip1<=X"FF"; dip3<=X"FF";
      when others => led<=led0; dip1<=X"FF"; dip3<=X"FF";
   end case;
end process;

lock_rx <= ftdi_mode or prog_mode or io_test_mode or music_mode or nand_mode;
rx_serial <= BDBUS0 when lock_rx = '0' else '1';

process(rx_data)
begin
	   case rx_data is
		when "00000000" => i2c_data_wr <= "00000000"; --welcome screen
      when "00110001" => i2c_data_wr <= "00000111"; --1
		when "00110010" => i2c_data_wr <= "00001110"; --2
		when "00110011" => i2c_data_wr <= "00010101"; --3
		when "00110100" => i2c_data_wr <= "00011100"; --4
		when "00110101" => i2c_data_wr <= "00100011"; --5
      when others => i2c_data_wr <= "00000000"; --any other
   end case;
end process;

start_iic <= rx_dv or power_up or five_sec or five_min or ten_min or NAND_test_result;

process(start_iic,stop_iic)
begin
  if (stop_iic = '1') then
      count_start <= '0';
  elsif (start_iic = '1') then
		count_start <= '1';
  end if;
end process;

	process(clk,count_start)
	begin
	  if (count_start='0') then
    count_d <= (others => '0');
  elsif (clk'event and clk = '1') then 
			count_d <= count_d + '1';
		end if;
	end process;

stop_iic <= '1' when count_d > X"FFFFFF" and i2c_busy='0' else '0';
ena_i2c_write <= '1' when count_d < X"6000" and count_start='1' else '0';
rw_i2c <= '0' when count_d < X"8000" else '1';
ena_i2c_read <= '1' when count_d > X"A000" else '0';
ena_i2c <= ena_i2c_write or ena_i2c_read;
tx_dv_en <= '1' when count_d > X"C000" else '0';
rst_i2c <= reset;

process(timer)
begin
   case timer(27 downto 24) is 
      when "0000" => led0 <= "00000001";
		when "0001" => led0 <= "00000001";
		when "0010" => led0 <= "00000010";
		when "0011" => led0 <= "00000100";
		when "0100" => led0 <= "00001000";
		when "0101" => led0 <= "00010000";
		when "0110" => led0 <= "00100000";
		when "0111" => led0 <= "01000000";
		when "1000" => led0 <= "10000000";
		when "1001" => led0 <= "10000000";
		when "1010" => led0 <= "01000000";
		when "1011" => led0 <= "00100000";
		when "1100" => led0 <= "00010000";
		when "1101" => led0 <= "00001000";
		when "1110" => led0 <= "00000100";
		when "1111" => led0 <= "00000010";
      when others => led0 <= "00000000";
   end case;
end process;

BDBUS1 <= ADBUS0 when ftdi_mode='1' and count_start='0' else tx_serial;
ADBUS1 <= BDBUS0;
BDBUS3 <= ADBUS2;
ADBUS3 <= BDBUS2;
BDBUS5 <= ADBUS4;
BDBUS6 <= ADBUS4;
BDBUS7 <= ADBUS4 when dip1(0)='1' else '0';
ADBUS5 <= BDBUS4;
ADBUS6 <= BDBUS4;
ADBUS7 <= BDBUS4 when dip1(1)='1' else '0';

LED1(0) <= ACBUS0;
LED1(1) <= not ACBUS1;
LED1(2) <= not ACBUS2;
LED1(3) <= not ACBUS3;
LED1(4) <= BCBUS0;
LED1(5) <= not BCBUS1;
LED1(6) <= not BCBUS2;
LED1(7) <= not BCBUS3;

LED2(0) <= SCL;
LED2(1) <= SDA;
LED2(2) <= '0';
LED2(3) <= '0';
LED2(4) <= '0';
LED2(5) <= '0';
LED2(6) <= R_B1;
LED2(7) <= R_B2;

i_o <= (J9&J10&J17&J5)&(not dip3);

io_sum <=
("0000000"&i_o(	0	))
+("0000000"&i_o(	1	))
+("0000000"&i_o(	2	))
+("0000000"&i_o(	3	))
+("0000000"&i_o(	4	))
+("0000000"&i_o(	5	))
+("0000000"&i_o(	6	))
+("0000000"&i_o(	7	))
+("0000000"&i_o(	8	))
+("0000000"&i_o(	9	))
+("0000000"&i_o(	10	))
+("0000000"&i_o(	11	))
+("0000000"&i_o(	12	))
+("0000000"&i_o(	13	))
+("0000000"&i_o(	14	))
+("0000000"&i_o(	15	))
+("0000000"&i_o(	16	))
+("0000000"&i_o(	17	))
+("0000000"&i_o(	18	))
+("0000000"&i_o(	19	))
+("0000000"&i_o(	20	))
+("0000000"&i_o(	21	))
+("0000000"&i_o(	22	))
+("0000000"&i_o(	23	))
+("0000000"&i_o(	24	))
+("0000000"&i_o(	25	))
+("0000000"&i_o(	26	))
+("0000000"&i_o(	27	))
+("0000000"&i_o(	28	))
+("0000000"&i_o(	29	))
+("0000000"&i_o(	30	))
+("0000000"&i_o(	31	))
+("0000000"&i_o(	32	))
+("0000000"&i_o(	33	))
+("0000000"&i_o(	34	))
+("0000000"&i_o(	35	))
+("0000000"&i_o(	36	))
+("0000000"&i_o(	37	))
+("0000000"&i_o(	38	))
+("0000000"&i_o(	39	))
+("0000000"&i_o(	40	))
+("0000000"&i_o(	41	))
+("0000000"&i_o(	42	))
+("0000000"&i_o(	43	))
+("0000000"&i_o(	44	))
+("0000000"&i_o(	45	))
+("0000000"&i_o(	46	))
+("0000000"&i_o(	47	))
+("0000000"&i_o(	48	))
+("0000000"&i_o(	49	))
+("0000000"&i_o(	50	))
+("0000000"&i_o(	51	))
+("0000000"&i_o(	52	))
+("0000000"&i_o(	53	))
+("0000000"&i_o(	54	))
+("0000000"&i_o(	55	))
+("0000000"&i_o(	56	))
+("0000000"&i_o(	57	))
+("0000000"&i_o(	58	))
+("0000000"&i_o(	59	))
+("0000000"&i_o(	60	))
+("0000000"&i_o(	61	))
+("0000000"&i_o(	62	))
+("0000000"&i_o(	63	))
+("0000000"&i_o(	64	))
+("0000000"&i_o(	65	))
+("0000000"&i_o(	66	))
+("0000000"&i_o(	67	))
+("0000000"&i_o(	68	))
+("0000000"&i_o(	69	))
+("0000000"&i_o(	70	))
+("0000000"&i_o(	71	))
+("0000000"&i_o(	72	))
+("0000000"&i_o(	73	))
+("0000000"&i_o(	74	))
+("0000000"&i_o(	75	))
+("0000000"&i_o(	76	))
+("0000000"&i_o(	77	))
+("0000000"&i_o(	78	))
+("0000000"&i_o(	79	))
+("0000000"&i_o(	80	))
+("0000000"&i_o(	81	))
+("0000000"&i_o(	82	))
+("0000000"&i_o(	83	))
+("0000000"&i_o(	84	))
+("0000000"&i_o(	85	))
+("0000000"&i_o(	86	))
+("0000000"&i_o(	87	))
+("0000000"&i_o(	88	))
+("0000000"&i_o(	89	))
+("0000000"&i_o(	90	))
+("0000000"&i_o(	91	))
+("0000000"&i_o(	92	))
+("0000000"&i_o(	93	))
+("0000000"&i_o(	94	))
+("0000000"&i_o(	95	))
+("0000000"&i_o(	96	))
+("0000000"&i_o(	97	))
+("0000000"&i_o(	98	))
+("0000000"&i_o(	99	))
+("0000000"&i_o(	100	))
+("0000000"&i_o(	101	))
+("0000000"&i_o(	102	))
+("0000000"&i_o(	103	))
+("0000000"&i_o(	104	))
+("0000000"&i_o(	105	))
+("0000000"&i_o(	106	))
+("0000000"&i_o(	107	))
+("0000000"&i_o(	108	))
+("0000000"&i_o(	109	))
+("0000000"&i_o(	110	))
+("0000000"&i_o(	111	))
+("0000000"&i_o(	112	))
+("0000000"&i_o(	113	))
+("0000000"&i_o(	114	))
+("0000000"&i_o(	115	))
+("0000000"&i_o(	116	))
+("0000000"&i_o(	117	))
+("0000000"&i_o(	118	))
+("0000000"&i_o(	119	))
+("0000000"&i_o(	120	))
+("0000000"&i_o(	121	))
+("0000000"&i_o(	122	))
+("0000000"&i_o(	123	))
+("0000000"&i_o(	124	))
+("0000000"&i_o(	125	))
+("0000000"&i_o(	126	))
+("0000000"&i_o(	127	))
+("0000000"&i_o(	128	))
+("0000000"&i_o(	129	))
+("0000000"&i_o(	130	))
+("0000000"&i_o(	131	))
+("0000000"&i_o(	132	))
+("0000000"&i_o(	133	))
+("0000000"&i_o(	134	))
+("0000000"&i_o(	135	))
+("0000000"&i_o(	136	))
+("0000000"&i_o(	137	))
+("0000000"&i_o(	138	))
+("0000000"&i_o(	139	))
+("0000000"&i_o(	140	))
+("0000000"&i_o(	141	))
+("0000000"&i_o(	142	))
+("0000000"&i_o(	143	))
+("0000000"&i_o(	144	))
+("0000000"&i_o(	145	))
+("0000000"&i_o(	146	))
+("0000000"&i_o(	147	))
+("0000000"&i_o(	148	))
+("0000000"&i_o(	149	));

ok <= '1' WHEN io_sum = "00000001" ELSE '0';

spkr <= sound1 when music_mode='0' else sound2;
sound1 <= timer(14) and ok and io_test_mode;

led3 <= X"FF" when ok='1' else X"00";
led4 <= X"FF" when timer(23)='1' else X"00";

process(timer,NAND_ID_OK)
begin
if (NAND_ID_OK = '0') then led5 <= "11111111";
else
   case timer(24 downto 23) is 
      when "00" => led5 <= "00011000";
		when "01" => led5 <= "00100100";
		when "10" => led5 <= "01000010";
		when "11" => led5 <= "10000001";
      when others => led5 <= "00000000";
   end case;
	end if;
end process;

process(s_5,stop_nand,power_up)
begin
  if (stop_nand = '1') or (power_up = '1') then
      n_count_start <= '0';
  elsif (s_5 = '1') then
		n_count_start <= '1';
  end if;
end process;

process(clk,n_count_start,read_second_chip)
begin
	if (n_count_start='0') or (read_second_chip='1') then
    count_n <= (others => '0');
 elsif (clk'event and clk = '1') then 
			count_n <= count_n + '1';
	end if;
end process;

stop_nand <= '1' when count_n > X"1111111" and R_B1='1' and R_B2='1' else '0';

WE <= '0' when ((count_n < X"6000") or (count_n > X"603E" and count_n < X"6066") or (count_n > X"617A" and count_n < X"61A2") 
or (count_n > X"61FD" and count_n < X"6225")) and n_count_start='1' else '1' when prog_mode = '0' else 'Z';

ALE <= '1' when (count_n > X"61E0" and count_n < X"6228" and n_count_start='1') else '0' when prog_mode = '0' else 'Z';

CLE <= '1' when ((count_n > X"6022" and count_n < X"6069") or (count_n > X"615E" and count_n < X"61A5")) and n_count_start='1' else '0' when prog_mode = '0' else 'Z';

RE <= '0' when ((count_n > X"6335" and count_n < X"6DFB") or (count_n > X"6E43" and count_n < X"7909") or (count_n > X"7951" and count_n < X"8417")
or (count_n > X"845F" and count_n < X"8F25") or (count_n > X"8F6D" and count_n < X"9A33")) and n_count_start='1' else '1' when prog_mode = '0' else 'Z'; -- five read cycles

NAND_IO <= X"FF" when (count_n < X"6171" and n_count_start='1') else --reset command
X"90" when (count_n > X"6171" and count_n < X"61F3" and n_count_start='1') else --read ID command
X"00" when (count_n > X"61F3" and count_n < X"6275" and n_count_start='1') else "ZZZZZZZZ"; --address. 1cycle

read_second_chip <= '1' when count_n = X"AAAA" and NAND_CE = '0' and n_count_start='1' else '0';

process(read_second_chip,n_count_start)
begin
	if (n_count_start='0') then
   NAND_CE <= '0';
 elsif (read_second_chip = '1') then 
	NAND_CE <= '1';
	end if;
end process;

WP  <= '1' when prog_mode = '0' else 'Z';
CE1 <= NAND_CE when prog_mode = '0' else 'Z';
CE2 <= not NAND_CE when prog_mode = '0' else 'Z';

check_cycle1 <= '1' when count_n = X"6898" and NAND_IO = X"EC" and n_count_start='1' else '0'; -- K9WAG08U1B maker code
check_cycle2 <= '1' when count_n = X"73A6" and NAND_IO = X"D3" and n_count_start='1' else '0'; -- K9WAG08U1B device code
check_cycle3 <= '1' when count_n = X"7EB4" and NAND_IO = X"51" and n_count_start='1' else '0'; -- K9WAG08U1B 3rd ID Data
check_cycle4 <= '1' when count_n = X"89C2" and NAND_IO = X"95" and n_count_start='1' else '0'; -- K9WAG08U1B 4th ID Data
check_cycle5 <= '1' when count_n = X"94D0" and NAND_IO = X"58" and n_count_start='1' else '0'; -- K9WAG08U1B 5th ID Data

process(check_cycle1,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C1_C1 <= '0'; -- chip1, read cycle 1
 elsif (check_cycle1 = '1' and NAND_CE = '0') then 
	C1_C1 <= '1';
	end if;
end process;

process(check_cycle2,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C1_C2 <= '0'; -- chip1, read cycle 2
 elsif (check_cycle2 = '1' and NAND_CE = '0') then 
	C1_C2 <= '1';
	end if;
end process;

process(check_cycle3,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C1_C3 <= '0'; -- chip1, read cycle 3
 elsif (check_cycle3 = '1' and NAND_CE = '0') then 
	C1_C3 <= '1';
	end if;
end process;

process(check_cycle4,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C1_C4 <= '0'; -- chip1, read cycle 4
 elsif (check_cycle4 = '1' and NAND_CE = '0') then 
	C1_C4 <= '1';
	end if;
end process;

process(check_cycle5,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C1_C5 <= '0'; -- chip1, read cycle 5
 elsif (check_cycle5 = '1' and NAND_CE = '0') then 
	C1_C5 <= '1';
	end if;
end process;

process(check_cycle1,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C2_C1 <= '0'; -- chip2, read cycle 1
 elsif (check_cycle1 = '1' and NAND_CE = '1') then 
	C2_C1 <= '1';
	end if;
end process;

process(check_cycle2,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C2_C2 <= '0'; -- chip2, read cycle 2
 elsif (check_cycle2 = '1' and NAND_CE = '1') then 
	C2_C2 <= '1';
	end if;
end process;

process(check_cycle3,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C2_C3 <= '0'; -- chip2, read cycle 3
 elsif (check_cycle3 = '1' and NAND_CE = '1') then 
	C2_C3 <= '1';
	end if;
end process;

process(check_cycle4,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C2_C4 <= '0'; -- chip2, read cycle 4
 elsif (check_cycle4 = '1' and NAND_CE = '1') then 
	C2_C4 <= '1';
	end if;
end process;

process(check_cycle5,nand_mode,NAND_CE)
begin
	if (nand_mode='0') then
   C2_C5 <= '0'; -- chip2, read cycle 5
 elsif (check_cycle5 = '1' and NAND_CE = '1') then 
	C2_C5 <= '1';
	end if;
end process;

NAND_ID_OK <= C1_C1 and C1_C2 and C1_C3 and C1_C4 and C1_C5 and C2_C1 and C2_C2 and C2_C3 and C2_C4 and C2_C5;

NAND_test_result <= '1' when count_n = X"1011111" else '0';

i2c_data_write <= "00101010" when (NAND_ID_OK = '1' and count_n > X"1010000" and count_n < X"1012222" and n_count_start='1') else
"00110001" when (NAND_ID_OK = '0' and count_n > X"1010000" and count_n < X"1012222" and n_count_start='1') else i2c_data_wr;

end Behavioral;